## grcompiler 5.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.11)
project(grcompiler)
enable_language(CXX C)
enable_testing()

include(TestBigEndian)
include(FetchContent)
include(CTest)

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED 11)
include(GNUInstallDirs)



if (NOT CMAKE_BUILD_TYPE)
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY VALUE Release)
endif()

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DWIN32 -D_WINDOWS)

    if (NOT DEFINED ICU_ROOT AND NOT DEFINED FETCHCONTENT_SOURCE_DIR_ICU)
        set(ICU_URL https://github.com/unicode-org/icu/releases/download/release-66-1/icu4c-66_1-Win32-MSVC2017.zip)
    endif()
endif()

add_subdirectory(doc)
add_subdirectory(preprocessor)
add_subdirectory(compiler)
add_subdirectory(test)

=== compiler/CMakeLists.txt ===
project(compiler VERSION 5.2)
cmake_policy(SET CMP0074 NEW)

FetchContent_Declare(icu URL ${ICU_URL})

if (DEFINED ICU_URL OR DEFINED FETCHCONTENT_SOURCE_DIR_ICU)
    FetchContent_GetProperties(icu)
    if (NOT icu_POPULATED)
        message(STATUS "Fetching: " ${ICU_URL})
        FetchContent_Populate(icu)
    endif()

    if (icu_POPULATED)
        set(ICU_ROOT ${icu_SOURCE_DIR}/${ICU_ROOT})
    else()
        set(ICU_ROOT "")
    endif()
endif()

find_package(ICU REQUIRED COMPONENTS uc i18n data)
message(STATUS "ICU Libraries: " ${ICU_VERSION})

add_subdirectory(Generic)
add_subdirectory(Grammar)
add_subdirectory(LZ4)

include_directories(Generic Grammar LZ4 ${ICU_INCLUDE_DIR})

add_library(TtfUtil OBJECT TtfUtil.cpp)

add_executable(grcompiler 
    Compiler.cpp 
    ErrorCheckClasses.cpp 
    ErrorCheckFeatures.cpp 
    ErrorCheckRules.cpp 
    Fsm.cpp 
    GlyphBoundaries.cpp 
    GdlExpression.cpp 
    GdlFeatures.cpp 
    GdlGlyphClassDefn.cpp 
    GdlRenderer.cpp 
    GdlRule.cpp 
    GdlTablePass.cpp 
    GrcErrorList.cpp 
    GrcFont.cpp 
    GrcGlyphAttrMatrix.cpp 
    GrcManager.cpp 
    GrcMasterTable.cpp 
    GrcSymTable.cpp 
    GrpExtensions.cpp 
    GrpLexer.cpp 
    GrpParser.cpp 
    GrpParserDebug.cpp 
    OutputToFont.cpp 
    ParserTreeWalker.cpp 
    PostParser.cpp 
    $<TARGET_OBJECTS:TtfUtil>
    main.cpp)

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    target_compile_options(grcompiler PRIVATE /Zc:wchar_t- /W3 /EHsc)
endif()

target_link_libraries(grcompiler ICU::uc ICU::i18n generic parser lz4)

if (icu_POPULATED)
    if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
        file(GLOB_RECURSE _icu_dlls "${icu_SOURCE_DIR}/**${CMAKE_SHARED_LIBRARY_SUFFIX}")
        add_custom_command(TARGET grcompiler POST_BUILD 
            COMMAND ${CMAKE_COMMAND} -E copy_if_different
                ${_icu_dlls}
                $<TARGET_FILE_DIR:grcompiler>)
    endif()
endif()

install(TARGETS grcompiler RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES stddef.gdh DESTINATION ${CMAKE_INSTALL_DATADIR}/${CMAKE_PROJECT_NAME})

=== doc/CMakeLists.txt ===
project(docs)

find_program(DOCBOOK2MAN NAMES docbook2x-man)

configure_file(gdlpp.1.in gdlpp.1 COPYONLY)
set(DOC_DEPENDS ${PROJECT_BINARY_DIR}/gdlpp.1)
file(GLOB DOCS *.pdf)
set(DOCS ${DOCS} README.gdlpp)

if (DOCBOOK2MAN)
    add_custom_command(
        OUTPUT ${PROJECT_BINARY_DIR}/grcompiler.1
        DEPENDS ${PROJECT_SOURCE_DIR}/grcompiler.1.xml
        COMMAND ${DOCBOOK2MAN} ${PROJECT_SOURCE_DIR}/grcompiler.1.xml)
    set(DOC_DEPENDS ${DOC_DEPENDS} ${PROJECT_BINARY_DIR}/grcompiler.1)
endif()

add_custom_target(docs ALL DEPENDS ${DOC_DEPENDS})
install(FILES ${DOC_DEPENDS} DESTINATION ${CMAKE_INSTALL_MANDIR})
install(FILES ${DOCS} DESTINATION ${CMAKE_INSTALL_DOCDIR}/${CMAKE_PROJECT_NAME})

=== test/CMakeLists.txt ===
project(test)

add_subdirectory(GrcRegressionTest)

enable_testing()

=== compiler/Grammar/CMakeLists.txt ===
project(parser)

include_directories(${PROJECT_SOURCE_DIR})

add_library(parser STATIC
    AST.cpp 
	ANTLRException.cpp 
	ASTFactory.cpp 
	BitSet.cpp 
	CharBuffer.cpp 
	CharScanner.cpp 
	CommonASTNode.cpp 
	CommonToken.cpp 
	InputBuffer.cpp 
	LexerSharedInputState.cpp 
	LLkParser.cpp 
	MismatchedTokenException.cpp 
	NoViableAltException.cpp 
	Parser.cpp 
	ParserException.cpp 
	ParserSharedInputState.cpp 
	ScannerException.cpp 
	String.cpp 
	Token.cpp 
	TokenBuffer.cpp)

=== compiler/LZ4/CMakeLists.txt ===
project(lz4)

add_library(lz4 STATIC lz4.c lz4hc.c)

=== test/GrcRegressionTest/CMakeLists.txt ===
project(grc_regression_test)

include_directories(${compiler_SOURCE_DIR})

add_executable(GrcRegressionTest
    CompareFontTables.cpp 
    FileInput.cpp 
    GrcRtFileFont.cpp 
    GrcRegressionTest.cpp 
    $<TARGET_OBJECTS:TtfUtil>)
target_link_libraries(GrcRegressionTest generic)

if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    target_compile_options(GrcRegressionTest PRIVATE /W3 /EHsc)
endif()


set(FONT_SOURCE_DIR ${PROJECT_SOURCE_DIR}/fonts)

function(compile_test FONT VERSION PSNAME)
    string(REGEX REPLACE "Test(_v${VERSION})?$" "" _input ${FONT})
    string(REGEX REPLACE "(^.+)Test" "\\1Benchmark" _benchmark ${FONT})

    # Compile the font
    add_test(NAME compile_${FONT}
        COMMAND grcompiler -D -v${VERSION} ${ARGN} -e ${PROJECT_BINARY_DIR}/${FONT}.gdlerr.txt ${FONT_SOURCE_DIR}/${_input}Main.gdl ${FONT_SOURCE_DIR}/${_input}Input.ttf ${FONT}.ttf ${PSNAME})
    set_tests_properties(compile_${FONT} PROPERTIES
        ENVIRONMENT "GDLPP=$<TARGET_FILE:gdlpp>;LD_LIBRARY_PATH=$LD_LIBRARY_PATH:${ICU_INCLUDE_DIR}/../lib"
#        ATTACHED_FILES ${PROJECT_BINARY_DIR}/${FONT}.gdlerr.log
        REQUIRED_FILES "${FONT_SOURCE_DIR}/${_input}Input.ttf;${FONT_SOURCE_DIR}/${_input}Main.gdl"
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR})


    # Run the regression tests
    add_test(NAME GrcRegressionTest_${FONT}
        COMMAND GrcRegressionTest -l ${PROJECT_BINARY_DIR}/${FONT}.grcregtest.log ${FONT_SOURCE_DIR}/${_benchmark}.ttf ${FONT}.ttf)
    set_tests_properties(GrcRegressionTest_${FONT} PROPERTIES
        DEPENDS compile_${FONT}
        REQUIRED_FILES "${FONT_SOURCE_DIR}/${_benchmark}.ttf;${FONT}.ttf"
#        ATTACHED_FILES ${PROJECT_BINARY_DIR}/${BENCHMARK_NAME}.grcregtest.log
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR})
    
    # Compare the output to the expected output
    add_test(NAME compare_${FONT}
        COMMAND ${CMAKE_COMMAND} -E compare_files ${FONT}.ttf ${FONT_SOURCE_DIR}/${_benchmark}.ttf)
    set_tests_properties(compare_${FONT} PROPERTIES
        DEPENDS compile_${FONT}
        REQUIRED_FILES "${FONT_SOURCE_DIR}/${_benchmark}.ttf;${FONT}.ttf"
        WORKING_DIRECTORY ${PROJECT_BINARY_DIR})
endfunction()

function(get_icu_dirs)
    string(REGEX MATCH "^[0-9]+" icu_major_version ${ICU_VERSION})
    file(GLOB icuders RELATIVE ${FONT_SOURCE_DIR} CONFIGURE_DEPENDS 
        ${FONT_SOURCE_DIR}/icu*)
    list(TRANSFORM icuders REPLACE "icu([0-9]+)$" "\\1")
    list(SORT icuders)
    list(REVERSE icuders)
    foreach(ver IN LISTS icuders)
        if (${ver} LESS_EQUAL ${icu_major_version})
            list(APPEND ICUDIRS "${ver}")
        endif()
    endforeach()
    set(ICUDIRS ${ICUDIRS} PARENT_SCOPE)
endfunction()

compile_test(SchTest 4 "")
compile_test(CharisTest 2 "")
compile_test(PigLatinTest_v2 2 "PigLatin GrRegTest V2" -p)
compile_test(PigLatinTest_v3 3 "")
compile_test(PadaukTest_v3 3 "" -offsets -p)

## grcompiler 4.2~pre4

=== debian/changelog ===
grcompiler (4.2~pre4-1) unstable; urgency=low

  * Fix lintian warnings
  * Upload to Debian (Closes: #614754)

 -- Daniel Glassey <wdg@debian.org>  Wed, 09 May 2012 13:55:35 +0700

grcompiler (4.2~pre2-1~palaso2) UNRELEASED; urgency=low

  * debian/copyright machine readable format

 -- Daniel Glassey <wdg@debian.org>  Mon, 07 May 2012 12:11:55 +0700

grcompiler (4.2~pre1-1~palaso1) UNRELEASED; urgency=low

  * New upstream version 4.2 prerelease
  * updated dependencies to suggest iceweasel/firefox and libreoffice
      in versions that have graphite support

 -- Daniel Glassey <wdg@debian.org>  Thu, 19 Apr 2012 14:04:58 +0700

grcompiler (2.4.3) lucid; urgency=low

  * use TtfUtils code from GrEngine

 -- Martin Hosken <martin_hosken@sil.org>  Tue, 14 Sep 2010 09:50:05 +0700

grcompiler (2.4.1-1ubuntu1) unstable; urgency=low

  * Bug fix release

 -- Martin Hosken <martin_hosken@sil.org>  Thu, 05 Feb 2009 09:15:25 +0700

grcompiler (2.1+0000svn-1) unstable; urgency=low

  * Initial Release from svn.

 -- Daniel Glassey <wdg@debian.org>  Sat,  1 Sep 2007 18:35:41 +0100

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: grcompiler
Build-Depends: autotools-dev, debhelper (>= 7.0.50~), docbook2x, pkg-config, libicu-dev (>= 4.2)
Build-Conflicts: libgtkhtml3.2-dev, libgtkhtml3.6-dev
Section: devel
Priority: optional
Maintainer: Daniel Glassey <wdg@debian.org>
Uploaders: Martin Hosken <martin_hosken@sil.org>
Standards-Version: 3.9.3.1

Package: grcompiler
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: libgraphite2-2.0.0, pango-graphite, iceweasel (>= 11.0) | firefox (>= 11.0), libreoffice
Description: Compiler of smart (graphite) fonts
 SILGraphite is a system that can be used to create and use "smart
 fonts" capable of displaying writing systems with various complex
 behaviors, such as: contextual shaping, ligatures, reordering, split
 glyphs, bidirectionality, stacking diacritics and complex positioning.
 .
 This library was designed and developed by the NRSI (Non-Roman Script
 Initiative) within SIL International (www.sil.org) to act as a
 complement to other smart font rendering technologies with limited
 practical local extensability. Its purpose is to help meet the needs of
 a very large number of "minority language" communities for local
 extensibility of complex script behaviors.
 .
 The behavior of the SILGraphite rendering engine for a given writing
 system is specified through extra tables added to a TrueType font. These
 tables are generated by compiling a GDL (Graphite Description Language)
 source file into a font using grcompiler.
 .
 This package contains the graphite compiler.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_compress:
	dh_compress -X.pdf

## grcompiler 4.2~pre5

=== debian/changelog ===
grcompiler (4.2~pre5-2) unstable; urgency=low

  * debian/control build-dep on debhelper 9
  * debian/compat 9 to get hardening flags

 -- Daniel Glassey <wdg@debian.org>  Fri, 01 Jun 2012 11:12:07 +0700

grcompiler (4.2~pre5-1) unstable; urgency=low

  * New upstream pre-release
  * debian/control Change maintainer to pkg-fonts team
  * fix EOF and char issue (Closes:#673723)

 -- Daniel Glassey <wdg@debian.org>  Wed, 30 May 2012 13:06:21 +0700

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: grcompiler
-Build-Depends: autotools-dev, debhelper (>= 7.0.50~), docbook2x, pkg-config, libicu-dev (>= 4.2)
+Build-Depends: autotools-dev, debhelper (>= 9.20120115), docbook2x, pkg-config, libicu-dev (>= 4.2)
 Build-Conflicts: libgtkhtml3.2-dev, libgtkhtml3.6-dev
 Section: devel
 Priority: optional
-Maintainer: Daniel Glassey <wdg@debian.org>
-Uploaders: Martin Hosken <martin_hosken@sil.org>
-Standards-Version: 3.9.3.1
+Maintainer: Debian Fonts Task Force <pkg-fonts-devel@lists.alioth.debian.org>
+Uploaders: Daniel Glassey <wdg@debian.org>, Martin Hosken <martin_hosken@sil.org>
+Standards-Version: 3.9.3
 
 Package: grcompiler
 Architecture: any

## grcompiler 4.2~pre6

=== debian/changelog ===
grcompiler (4.2~pre6-1) unstable; urgency=low

  * New upstream release
  * don't get full ldflags from icu-config (with PIE hardening flags)

 -- Daniel Glassey <wdg@debian.org>  Thu, 07 Jun 2012 17:04:27 +0700

## grcompiler 4.2

=== debian/changelog ===
grcompiler (4.2-7build2) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:32:51 +0100

grcompiler (4.2-7build1) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 13 Feb 2020 08:57:43 +0100

grcompiler (4.2-7) unstable; urgency=medium

  * Team upload

  [ Daniel Glassey ]
  * d/control:
    - update Vcs-* for salsa
    - build dep on debhelper 11
    - update team maintainer to debian-fonts@lists.debian.org
  * compat level 11
  * d/watch: grcompiler is now on gihub
      thanks to bgermann for the PR

  [ Hideki Yamane ]
  * debian/patches
    - add icu_pkg-config.patch (Closes: #916123)
  * debian/control
    - set Standards-Version: 4.3.0
    - Suggests: drop iceweasel and add "gnome-www-browser | firefox-esr"
    - drop unnecessary "Build-depends: dh-autoreconf"
    - use dh12, set "Build-Depends: debhelper (>= 12), debhelper-compat (= 12)"
    - fix wrong Vcs-Git url
    - Add Homepage: field
  * debian/copyright
    - use https for copyright format URL

 -- Hideki Yamane <henrich@debian.org>  Wed, 02 Jan 2019 14:28:41 +0900

grcompiler (4.2-6) unstable; urgency=medium

  * Team upload
  * debian/patches
    - add 0002-set-OK_DATE-FALSE-for-reproducible-build.patch
  * debian/control
    - update Vcs-*: use https and cgit

 -- Hideki Yamane <henrich@debian.org>  Tue, 26 Jan 2016 22:00:58 +0900

grcompiler (4.2-5) unstable; urgency=medium

  * Team upload
  * debian/rules
    - add hardening flags, and hope also fix reproducible build issue
  * debian/control
    - set Standards-Version: 3.9.6

 -- Hideki Yamane <henrich@debian.org>  Sat, 06 Jun 2015 13:15:15 +0900

grcompiler (4.2-4) unstable; urgency=medium

  * Team upload
  * debian/rules
    - run run dh-autoreconf to update config.{sub,guess} and
      {libtool,aclocal}.m4 (Closes: #727880)
    - also it fixes "FTBFS: Makefile:596: *** missing separator (did you mean
      TAB instead of 8 spaces?). Stop." since reconf would update wrong
      Makefile.in (Closes: #750282)
  * debian/control
    - replace s/autotools-dev/dh-autoreconf/
  * debian/copyright
    - fix spell error

 -- Hideki Yamane <henrich@debian.org>  Wed, 29 Jan 2014 20:55:10 +0900

grcompiler (4.2-3) unstable; urgency=medium

  * Team upload
  * debian/patches
    - add fix_GrcRegressionTest_Makefile.patch to fix FTBFS
      (Closes: #724916)
  * debian/control
    - use libgraphite2-3 for Suggests, Thanks to Rene Engelhard
     <rene@debian.org> (Closes: #707121)

 -- Hideki Yamane <henrich@debian.org>  Wed, 08 Jan 2014 14:48:34 +0900

grcompiler (4.2-2) unstable; urgency=low

  * Team upload
  * Fix typo in changelog: extensibility.
    Thanks to Reuben Thomas. Closes: #693972
  * Build with autotools_dev to use up-to-date config.{guess,sub}
    Thanks to Matthias Klose.
    Closes: #727880
  * Use git for packaging: add Vcs-* fields
  * Update Standards to 3.9.5 (checked)

 -- Christian Perrier <bubulle@debian.org>  Sun, 01 Dec 2013 19:50:31 +0100

grcompiler (4.2-1) unstable; urgency=low

  * New upstream release
  * LIBS not LDFLAGS for icu ldflags, Closes: #677671
       Thanks to Julian Taylor for the patch

 -- Daniel Glassey <wdg@debian.org>  Wed, 27 Jun 2012 10:40:59 +0700

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,19 @@
 Source: grcompiler
-Build-Depends: autotools-dev, debhelper (>= 9.20120115), docbook2x, pkg-config, libicu-dev (>= 4.2)
+Build-Depends: debhelper (>= 12), debhelper-compat (= 12), docbook2x, pkg-config, libicu-dev (>= 4.2)
 Build-Conflicts: libgtkhtml3.2-dev, libgtkhtml3.6-dev
 Section: devel
 Priority: optional
-Maintainer: Debian Fonts Task Force <pkg-fonts-devel@lists.alioth.debian.org>
+Maintainer: Debian Fonts Task Force <debian-fonts@lists.debian.org>
 Uploaders: Daniel Glassey <wdg@debian.org>, Martin Hosken <martin_hosken@sil.org>
-Standards-Version: 3.9.3
+Standards-Version: 4.3.0
+Vcs-Browser: https://salsa.debian.org/fonts-team/grcompiler
+Vcs-Git: https://salsa.debian.org/fonts-team/grcompiler.git
+Homepage: https://github.com/silnrsi/grcompiler
 
 Package: grcompiler
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: libgraphite2-2.0.0, pango-graphite, iceweasel (>= 11.0) | firefox (>= 11.0), libreoffice
+Suggests: libgraphite2-3, pango-graphite, gnome-www-browser | firefox-esr, libreoffice
 Description: Compiler of smart (graphite) fonts
  SILGraphite is a system that can be used to create and use "smart
  fonts" capable of displaying writing systems with various complex
@@ -20,7 +23,7 @@
  This library was designed and developed by the NRSI (Non-Roman Script
  Initiative) within SIL International (www.sil.org) to act as a
  complement to other smart font rendering technologies with limited
- practical local extensability. Its purpose is to help meet the needs of
+ practical local extensibility. Its purpose is to help meet the needs of
  a very large number of "minority language" communities for local
  extensibility of complex script behaviors.
  .

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_compress:
	dh_compress -X.pdf

## grcompiler 5.2

=== debian/changelog ===
grcompiler (5.2-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Patch: Prevent year sensitive test (Closes: #980699)

 -- Bastian Germann <bastiangermann@fishpost.de>  Sat, 13 Feb 2021 15:27:23 +0100

grcompiler (5.2-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add upstream patches for big endian (Closes: #961444, #961445)
  * Add upstream patch for font names (Closes: #961438)
  * d/copyright: Add missing Upstream-Contact

 -- Bastian Germann <bastiangermann@fishpost.de>  Tue, 08 Sep 2020 17:44:40 +0200

grcompiler (5.2-2) unstable; urgency=medium

  * Team upload 
  * debian/patches
    - Add 0004-Bug#961444.patch, taken from upstream git to deal with
      "FTBFS on architectures where char is unsigned" (Closes: #961444)

 -- Hideki Yamane <henrich@debian.org>  Sun, 16 Aug 2020 18:41:30 +0900

grcompiler (5.2-1) unstable; urgency=medium

  * Team upload

  * New Upstream Version 5.2 (Closes: #961226)

  [ Bastian Germann ]
  * Build with LZ4
  * Refresh patches
  * Update debhelper to v13
  * Lintian: rules-requires-root-missing
  * d/copyright: correct info, add BSD license
  * d/copyright: move 2x referenced license
  * d/copyright: add admin dir's licenses
  * Remove unnecessary Build-Conflicts
  * Build with CMake
  * Patch: Fix man install path for cmake

  [ Hideki Yamane ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Update standards version to 4.5.0, no changes needed.
  * Add debian/salsa-ci.yml

 -- Hideki Yamane <henrich@debian.org>  Sun, 24 May 2020 21:09:38 +0900

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,11 @@
 Source: grcompiler
-Build-Depends: debhelper (>= 12), debhelper-compat (= 12), docbook2x, pkg-config, libicu-dev (>= 4.2)
-Build-Conflicts: libgtkhtml3.2-dev, libgtkhtml3.6-dev
+Build-Depends: cmake, debhelper-compat (= 13), docbook2x, pkg-config, libicu-dev (>= 4.2), liblz4-dev
 Section: devel
 Priority: optional
 Maintainer: Debian Fonts Task Force <debian-fonts@lists.debian.org>
 Uploaders: Daniel Glassey <wdg@debian.org>, Martin Hosken <martin_hosken@sil.org>
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
+Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/fonts-team/grcompiler
 Vcs-Git: https://salsa.debian.org/fonts-team/grcompiler.git
 Homepage: https://github.com/silnrsi/grcompiler

## grcompiler 5.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,11 +7,11 @@
 include(FetchContent)
 include(CTest)
 
-set(CMAKE_CXX_STANDARD 11)
-set(CMAKE_CXX_STANDARD_REQUIRED 11)
+set(CMAKE_CXX_STANDARD 14)
+set(CMAKE_CXX_STANDARD_REQUIRED 14)
 include(GNUInstallDirs)
 
-
+test_big_endian(BIGENDIAN_SYSTEM)
 
 if (NOT CMAKE_BUILD_TYPE)
     set_property(CACHE CMAKE_BUILD_TYPE PROPERTY VALUE Release)
@@ -21,7 +21,8 @@
     add_definitions(-D_SCL_SECURE_NO_WARNINGS -D_CRT_SECURE_NO_WARNINGS -DWIN32 -D_WINDOWS)
 
     if (NOT DEFINED ICU_ROOT AND NOT DEFINED FETCHCONTENT_SOURCE_DIR_ICU)
-        set(ICU_URL https://github.com/unicode-org/icu/releases/download/release-66-1/icu4c-66_1-Win32-MSVC2017.zip)
+        string(REGEX REPLACE "^x64$" "Win64" _icu_platform_name ${CMAKE_VS_PLATFORM_NAME})
+        set(ICU_URL https://github.com/unicode-org/icu/releases/download/release-66-1/icu4c-66_1-${_icu_platform_name}-MSVC2017.zip)
     endif()
 endif()

=== compiler/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-project(compiler VERSION 5.2)
+project(compiler VERSION 5.2.1)
 cmake_policy(SET CMP0074 NEW)
 
 FetchContent_Declare(icu URL ${ICU_URL})
@@ -27,6 +27,7 @@
 include_directories(Generic Grammar LZ4 ${ICU_INCLUDE_DIR})
 
 add_library(TtfUtil OBJECT TtfUtil.cpp)
+target_compile_definitions(TtfUtil PUBLIC $<${BIGENDIAN_SYSTEM}:WORDS_BIGENDIAN>)
 
 add_executable(grcompiler 
     Compiler.cpp 
@@ -56,12 +57,11 @@
     PostParser.cpp 
     $<TARGET_OBJECTS:TtfUtil>
     main.cpp)
-
+target_compile_definitions(grcompiler PRIVATE $<${BIGENDIAN_SYSTEM}:WORDS_BIGENDIAN>)
+target_link_libraries(grcompiler ICU::uc ICU::i18n generic parser lz4)
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
     target_compile_options(grcompiler PRIVATE /Zc:wchar_t- /W3 /EHsc)
 endif()
-
-target_link_libraries(grcompiler ICU::uc ICU::i18n generic parser lz4)
 
 if (icu_POPULATED)
     if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

=== doc/CMakeLists.txt ===
--- 
+++ 
@@ -16,5 +16,5 @@
 endif()
 
 add_custom_target(docs ALL DEPENDS ${DOC_DEPENDS})
-install(FILES ${DOC_DEPENDS} DESTINATION ${CMAKE_INSTALL_MANDIR})
+install(FILES ${DOC_DEPENDS} DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)
 install(FILES ${DOCS} DESTINATION ${CMAKE_INSTALL_DOCDIR}/${CMAKE_PROJECT_NAME})

=== preprocessor/CMakeLists.txt ===
project(preprocessor VERSION 1.5.1)

add_executable(gdlpp cpp1.c cpp2.c cpp3.c cpp4.c cpp5.c cpp6.c memory.c usecpp.c)
target_compile_definitions(gdlpp PRIVATE 
    unix UNIX
    GDLPP 
    PKGDATADIR="${CMAKE_INSTALL_FULL_DATADIR}/${CMAKE_PROJECT_NAME}")

if  (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    target_compile_options(gdlpp PRIVATE /W3 /EHsc)
endif()


install(TARGETS gdlpp RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== compiler/Generic/CMakeLists.txt ===
project(generic)
if  (NOT ${CMAKE_SYSTEM_NAME} STREQUAL "Windows")
    find_package(Iconv)
endif()

add_library(generic STATIC Platform.cpp)
add_definitions(-DGR_NAMESPACE)

if (Iconv_FOUND)
    target_link_libraries(generic ${Iconv_LIBRARY})
endif()

=== compiler/Grammar/CMakeLists.txt ===
--- 
+++ 
@@ -20,6 +20,5 @@
 	ParserException.cpp 
 	ParserSharedInputState.cpp 
 	ScannerException.cpp 
-	String.cpp 
 	Token.cpp 
 	TokenBuffer.cpp)

=== test/GrcRegressionTest/CMakeLists.txt ===
--- 
+++ 
@@ -8,6 +8,7 @@
     GrcRtFileFont.cpp 
     GrcRegressionTest.cpp 
     $<TARGET_OBJECTS:TtfUtil>)
+target_compile_definitions(GrcRegressionTest PRIVATE $<${BIGENDIAN_SYSTEM}:WORDS_BIGENDIAN>)
 target_link_libraries(GrcRegressionTest generic)
 
 if (${CMAKE_SYSTEM_NAME} STREQUAL "Windows")

=== debian/changelog ===
grcompiler (5.2.1-1build1) noble; urgency=medium

  * No-change rebuild for ICU soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 11:06:15 +0100

grcompiler (5.2.1-1) unstable; urgency=medium

  * Team upload
  * Patch: Add missing include (Closes: #1037684)

 -- Bastian Germann <bage@debian.org>  Wed, 14 Jun 2023 14:18:03 +0200

grcompiler (5.2.1-0.2) unstable; urgency=medium

  * Non-maintainer upload
  * Add docbook-xml to prevent "Attempt to load network entity"
  * Add missing WORDS_BIGENDIAN definition (Closes: #1018896)

 -- Bastian Germann <bage@debian.org>  Mon, 24 Oct 2022 00:18:35 +0200

grcompiler (5.2.1-0.1) unstable; urgency=medium

  * Non-maintainer upload
  * New upstream version 5.2.1 (Closes: #993261)
  * Drop upstream patches
  * Patch: Prevent FetchContent_Declare with empty URL (Closes: #1017289)

 -- Bastian Germann <bage@debian.org>  Tue, 23 Aug 2022 20:54:47 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: grcompiler
-Build-Depends: cmake, debhelper-compat (= 13), docbook2x, pkg-config, libicu-dev (>= 4.2), liblz4-dev
+Build-Depends: cmake, debhelper-compat (= 13), docbook-xml, docbook2x, pkg-config, libicu-dev (>= 4.2), liblz4-dev
 Section: devel
 Priority: optional
 Maintainer: Debian Fonts Task Force <debian-fonts@lists.debian.org>

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/grcompiler-$1\.tar\.gz/ \
  https://github.com/silnrsi/grcompiler/tags .*/v?(\d\S+)\.tar\.gz
